/* include servproc */
#include	"mydoor.h"

void
servproc(void *cookie, char *dataptr, size_t datasize,
		 door_desc_t *descptr, uint_t ndesc)
{
	long	arg, result;
	
	arg = *((long *) dataptr);
	printf("thread id %ld, arg = %ld\n", pr_thread_id(NULL), arg);
	sleep(5);
	result = arg * arg;
	door_return((char *) &result, sizeof(result), NULL, 0);
}
/* end servproc */

/* include my_thread */
pthread_mutex_t	fdlock = PTHREAD_MUTEX_INITIALIZER;
static int	fd = -1;		/* door descriptor */

void *
my_thread(void *arg)
{
	int		oldstate;
	door_info_t	*iptr = arg;

	if ((door_server_proc *) iptr->di_proc == servproc) {
		pthread_mutex_lock(&fdlock);
		pthread_mutex_unlock(&fdlock);
		pthread_setcancelstate(PTHREAD_CANCEL_DISABLE, &oldstate);
		door_bind(fd);
		door_return(NULL, 0, NULL, 0);
	} else err_quit("my_thread: unknown function: ");
	return(NULL);	/* never executed */
}

void
my_create(door_info_t *iptr)
{
	pthread_t	tid;
	pthread_attr_t	attr;

	pthread_attr_init(&attr);
	pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	pthread_create(&tid, &attr, my_thread, (void *) iptr);
	pthread_attr_destroy(&attr);
	printf("my_thread: created server thread %ld\n", pr_thread_id(&tid));
}
/* end my_thread */

/* include main */
int
main(int argc, char **argv)
{
	if (argc != 2)
		err_quit("usage: server6 <server-pathname>");

	door_server_create(my_create);
   /* create a door descriptor and attach to pathname */
	pthread_mutex_lock(&fdlock);
	fd = door_create(servproc, NULL, DOOR_PRIVATE);
	pthread_mutex_unlock(&fdlock);
	unlink(argv[1]);
	close(open(argv[1], O_CREAT | O_RDWR, FILE_MODE));
	fattach(fd, argv[1]);
   /* servproc() handles all client requests */
	for ( ; ; )
		pause();
}
/* end main */
