/* include servproc */
#include	"mydoor.h"
#include	<math.h>
#include	"squareproc.h"
#include	"sqrtproc.h"

void
squareproc(void *cookie, char *dataptr, size_t datasize,
		   door_desc_t *descptr, uint_t ndesc)
{
	squareproc_in_t	in;
	squareproc_out_t	out;
	
	memcpy(&in, dataptr, min(sizeof(in), datasize));
	printf("squareproc: thread id %ld, arg = %ld\n",
		   pr_thread_id(NULL), in.arg1);
	sleep(5);
	out.res1 = in.arg1 * in.arg1;
	door_return((char *) &out, sizeof(out), NULL, 0);
}

void
sqrtproc(void *cookie, char *dataptr, size_t datasize,
		 door_desc_t *descptr, uint_t ndesc)
{
	sqrtproc_in_t	in;
	sqrtproc_out_t	out;
	
	memcpy(&in, dataptr, min(sizeof(in), datasize));
	printf("sqrtproc: thread id %ld, arg = %ld\n",
		   pr_thread_id(NULL), in.arg1);
	sleep(5);
	out.res1 = sqrt((double) in.arg1);
	door_return((char *) &out, sizeof(out), NULL, 0);
}
/* end servproc */

int
main(int argc, char **argv)
{
	int	fd;

	if (argc != 1) err_quit("usage: server7");
	fd = door_create(squareproc, NULL, 0);
	unlink(PATH_SQUARE_DOOR);
	close(open(PATH_SQUARE_DOOR, O_CREAT | O_RDWR, FILE_MODE));
	fattach(fd, PATH_SQUARE_DOOR);
	fd = door_create(sqrtproc, NULL, 0);
	unlink(PATH_SQRT_DOOR);
	close(open(PATH_SQRT_DOOR, O_CREAT | O_RDWR, FILE_MODE));
	fattach(fd, PATH_SQRT_DOOR);
	for ( ; ; )
		pause();
}
