#include	"mydoor.h"
#include    <thread.h>

void
server(void *cookie, char *argp, size_t arg_size,
	   door_desc_t *dp, uint_t n_descriptors)
{
	long	*arg, result[4];
	door_cred_t	info;
	
	if (argp == DOOR_UNREF_DATA) {
		printf("door unreferenced\n");
		door_return(NULL, 0, NULL, 0);
	}

	printf("server called, thread id %ld, %ld bytes of arguments, cookie = %p\n",
		   pr_thread_id(NULL), arg_size, cookie);
sleep(3);
	door_cred(&info);
	printf("euid = %ld, ruid = %ld, pid = %ld\n",
		   (long) info.dc_euid, (long) info.dc_ruid, (long) info.dc_pid);

	arg = (long *) argp;
	printf("arg[0] = %ld, arg[1] = %ld, arg[2] = %ld, arg[3]= %ld\n\n",
			arg[0], arg[1], arg[2], arg[3]);

	result[0] = arg[0] * arg[0];
	result[1] = arg[1] * arg[1];
	result[2] = arg[2] * arg[2];
	result[3] = arg[3] * arg[3];
	door_return((char *) result, sizeof(result), NULL, 0);
}

static int	fd = -1;

void *my_thread(void *arg)
{
	int		oldstate;

	if (arg == server) {
		while (fd == -1)
			thr_yield();

		pthread_setcancelstate(PTHREAD_CANCEL_DISABLE, &oldstate);
		door_bind(fd);
		door_return(NULL, 0, NULL, 0);
	} else
		err_quit("my_thread: unknown function");
	return(NULL);	/* never executed */
}

void
my_create(door_info_t *iptr)
{
	pthread_t	tid;
	pthread_attr_t	attr;

printf("tserver1: iptr = %p\n", iptr);
	pthread_attr_init(&attr);
	pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	pthread_create(&tid, &attr, my_thread, (void *) iptr->di_proc);
	pthread_attr_destroy(&attr);
	printf("created server thread %ld\n", pr_thread_id(&tid));
}

int
main(int argc, char **argv)
{
	struct stat	stat;

	if (argc != 2)
		err_quit("usage: server1 <pathname>");

	door_server_create(my_create);

		/* 4create a door descriptor */
	fd = door_create(server, (void *) 44, DOOR_PRIVATE);
	fstat(fd, &stat);
	printf("server() at %p, fmt = %lx\n", server,
		   (long) stat.st_mode & S_IFMT);

		/* 4bind it to the specified pathname */
	unlink(argv[1]);
	close(open(argv[1], O_CREAT | O_EXCL | O_RDWR, FILE_MODE));
	fattach(fd, argv[1]);
	/* close(fd); */

		/* server() handles all client requests */
	for ( ; ; )
		pause();
}
